# Wobuzz

Wobuzz is a simple audio player made by The Wobbler.
Currently, it just has really basic features but many more things are planned.
The player has its own playlist file format that is similar to extended m3u. [WOBUZZM3U](https://gulm.i21k.de/index.php?title=WOBUZZM3U)

![](https://emil.i21k.de/files/Wobuzz-Screenshot.png)

Please note that [the repository on teapot.informationsanarchistik.de](https://teapot.informationsanarchistik.de/Wobbl/Wobuzz) is the original repository and the [repository on Codeberg](https://codeberg.org/Wobbl/Wobuzz) is a mirror,
normal users only have read rights on the original repository because registration is disabled on the server.
Issues and pull-requests are not synced.

### Features (Implemented & Planned)

| Feature                         | Description                                                                                                                                                                                          | State                                                    |
|---------------------------------|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|----------------------------------------------------------|
| Playlists                       | You can create and load `.m3u` playlists, edit them and they will get stored on the disk automatically.                                                                                              | <input type="checkbox" disabled checked /> Implemented   |
| Background Job Monitor          | A QDockWidget where background processes are listed.                                                                                                                                                 | <input type="checkbox" disabled checked /> Implemented   |
| MPRIS Integration               | Basic MPRIS integration (Partial Metadata, Play, Pause, Stop, Next, Previous)                                                                                                                        | <input type="checkbox" disabled /> Partially Implemented |
| Audio effects                   | Audio effects like normalizing and an equalizer. This can be implemented pretty easily because Wobuzz uses [Pydub](https://pydub.com/), which has these effects built in.                            | <input type="checkbox" disabled /> Not Implemented       |
| Soundcloud downloader           | A simple Soundcloud-downloader like maybe integrating [SCDL](https://pypi.org/project/scdl/) would be really cool.                                                                                   | <input type="checkbox" disabled /> Not Implemented       |
| Synchronisation between devices | This should be pretty hard to implement and idk. if i will ever make it, but synchronisation could be pretty practical e.g. if you have multiple audio systems in different rooms.                   | <input type="checkbox" disabled /> Not Implemented       |
| Audio visualization             | Firstly, rather simple audio visualization like an oscilloscope would be cool, also something more complicated like [ProjectM](https://github.com/projectM-visualizer/projectm) could be integrated. | <input type="checkbox" disabled /> Not Implemented       |

### Performance

Currently, Wobuzz is relatively CPU-friendly in comparison to other audio players, but not RAM-friendly.
In comparison to Audacious, Wobuzz uses half as much CPU, but more than double the RAM.
This is because Audacious loads the audio only partially, while Wobuzz loads the entire track and the following one.
In the future, this may get optimized and CPU-usage could increase due to more features.

## Installation

#### Compatibility

Wobuzz was only made for Linux. 
It should not require that much effort to make it compatible with windows or mac, but why should anyone do that???
Currently (v0.1a2) Wobuzz is not really tested for compatibility, but it should run without problems on rather
new Debian-based distros like Mint 22. \
Also, the Python version should be newer than Python3.9

### Release installation

Look at the [Releases](https://teapot.informationsanarchistik.de/Wobbl/Wobuzz/releases),
there you can find the commands that you need for the installation.

### Unstable git installation

You firstly have to install the newest dependencies:

``` bash
sudo apt install xcb libxcb-cursor0 ffmpeg python3-pip git
```

Now, you can install the newest unstable version using just one more command:

```bash
pip install wobuzz@git+https://teapot.informationsanarchistik.de/Wobbl/Wobuzz.git#egg=wobuzz
```

### Development installation

If you want to make changes to the code,
you can clone the repo and install it this time using the `-e` parameter, 
which will tell pip to not copy the project to `~/.local/lib/python3.x/site-packages`,
but to create symlinks. \
Using this method, you can put the project wherever you want
(e.g. your Pycharm projects folder)
and the Python-module will always be in sync with the changes you do.

``` bash
git clone https://teapot.informationsanarchistik.de/Wobbl/Wobuzz.git
cd Wobuzz
pip install -e .
```

## Usage:

``` bash
usage: wobuzz [-h] [-p PLAYLIST_PATH] [TRACKS ...]

A music player made by The Wobbler.

positional arguments:
  TRACKS                Plays audio files the from given paths.

options:
  -h, --help            show this help message and exit
  -p PLAYLIST_PATH, --playlist PLAYLIST_PATH
                        Imports a playlist from the given path.

```